#extension GL_ARB_texture_rectangle : enable
#extension GL_EXT_gpu_shader4 : enable

uniform sampler2DRect image1;
uniform sampler2DRect image2;

uniform vec3 param1;	// R = mode (Mult or Difference)
uniform vec3 param2;
uniform vec3 param3;
uniform vec3 param4;
uniform vec3 param5;

void main()
{
    vec3 c = texture2DRect(image1, gl_TexCoord[0].xy).rgb;
    vec3 s = texture2DRect(image2, gl_TexCoord[0].xy).rgb;

	vec3 outColor;

	float mode = param1.x;

    //
    // Mult
    //
    if (mode <= 0.0) {
        outColor = c * s;
    //
    // Difference
    //
    } else {
        outColor = abs(c - s);
    }

	gl_FragColor = vec4(outColor, 1.0);
}
