#extension GL_ARB_texture_rectangle : enable
#extension GL_EXT_gpu_shader4 : enable

uniform sampler2DRect image;

uniform vec3 param1;	// R = size (0.0 - 100.0)
uniform vec3 param2;	// RGB = color (0.0 - 1.0)
uniform vec3 param3;	// R = softness (0.0 - 1.0)
uniform vec3 param4;
uniform vec3 param5;

void main()
{
    float x = gl_TexCoord[0].x;
    float y = gl_TexCoord[0].y;
   
	float size = floor(max(param1.x, 0.1) * 10.0);
	vec3 color = clamp(param2, vec3(0.0), vec3(1.0));
	float soft = clamp(param3.x, 0.0, 1.0);

    int cx = int(x) % int(size);
    int cy = int(y) % int(size);
    int ctx = int(x) / int(size);
    int cty = int(y) / int(size);

    x -= (size * float(ctx));
    y -= (size * float(cty));
    x -= (size / 2.0);
    y -= (size / 2.0);

    float d = sqrt(x * x + y * y);
    d = 1.0 - (d / size * 2.0); 
    d = d * (((1.0 - soft) * 10.0) + 1.0);
    d = min(d, 1.0);
    vec2 coords = vec2((size * float(ctx)) + (size / 2.0),
                       (size * float(cty)) + (size / 2.0));
    vec3 c = max(texture2DRect(image, coords).rgb, vec3(0.0));

    c = c * d * color;
    gl_FragColor = vec4(c, 1.0);
}
