#version 120
#extension GL_ARB_texture_rectangle : enable
#extension GL_EXT_gpu_shader4 : enable

uniform sampler2DRect image;

uniform vec3 param1;
uniform vec3 param2;
uniform vec3 param3;
uniform vec3 param4;
uniform vec3 param5;

float fromGamma(float v, float gamma)
{
    return (v >= 0.0) ? pow(v, gamma) : -pow(-v, gamma);
}

float toRec709(float v)
{
    return (v < 0.018053968510807) ? (v * 4.5) : (1.09929682680944 * pow(v, 0.45) - 0.09929682680944);
}

void main()
{
    vec4 p = texture2DRect(image, gl_TexCoord[0].xy);

    float r = fromGamma(p.r, 2.4);
    float g = fromGamma(p.g, 2.4);
    float b = fromGamma(p.b, 2.4);
    float a = p.a;
    
    r = toRec709(r);
    g = toRec709(g);
    b = toRec709(b);

    gl_FragColor = vec4(r, g, b, a);
}
