#version 120
#extension GL_ARB_texture_rectangle : enable
#extension GL_EXT_gpu_shader4 : enable

uniform sampler2DRect image;

uniform vec3 param1;
uniform vec3 param2;
uniform vec3 param3;
uniform vec3 param4;
uniform vec3 param5;

float fromRec709(float v)
{
    return (v < (0.018053968510807 * 4.5)) ? ((1.0 / 4.5) * v) : (pow((v + 0.09929682680944) * (1.0 / 1.09929682680944), (1.0 / 0.45)));
}

float toGamma(float v, float gamma)
{
    return (v >= 0.0) ? pow(v, (1.0 / gamma)) : -pow(-v, (1.0 / gamma));
}

void main()
{
    vec4 p = texture2DRect(image, gl_TexCoord[0].xy);

    float r = fromRec709(p.r);
    float g = fromRec709(p.g);
    float b = fromRec709(p.b);
    float a = p.a;
    
    r = toGamma(r, 2.4);
    g = toGamma(g, 2.4);
    b = toGamma(b, 2.4);

    gl_FragColor = vec4(r, g, b, a);
}
